/*
    socklibpp library
    Copyright (C) 2005  Daniel K. O. <danielosmari at users.sf.net>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


#include "sockcommon.h"

namespace socklibpp {

/**
        \namespace socklibpp
        \brief This is the namespace where the entire library lives in.
        
        This namespace is used to avoid name clashes. In your programs you'll
        probably find more pratical to use something like:

                namespace socklibpp = sock;

*/




#ifdef WIN32

namespace {
        class WinsockInit {
                WinsockInit()
                {
                        WSADATA data;
                        WSAStartup(MAKEWORD(2, 0), &data);
                }
                
                ~WinsockInit()
                {
                        WSACleanup();
                }
                
                static WinsockInit init;
        };
        
        WinsockInit WinsockInit::init;
}

int __WinSock_dummy_int = 0;

#endif // WIN32



}
