#include <iostream>
#include <ctime>
#include <socklibpp/sockstream.h>

using namespace std;
using namespace socklibpp;

int main()
{
        addr_in local(addr_in::addr_any, 0);
        local.port("daytime");

        sock server;
        
        server.create(sock::pf_inet, sock::sock_stream);
        
        if (!server.bind(local)) {
                cerr << "Could not bind: " << server.error << endl;
                return 1;
        }
        
        if (!server.listen()) {
                cerr << "Could not listen: " << server.error << endl;
                return 1;
        }

        cout << "Running daytime server on " << local << endl;
        
        while (1) {
                addr_in client_addr;
                sock client = server.accept(client_addr);
                
                cout << "Serving client " << client_addr << endl;
                
                // Let's not receive anything from the client
                client.shutdown(sock::shut_recv);
                
                time_t now = time(0);
                const char * timestr = ctime(&now);

                client.send(timestr, strlen(timestr));

                client.close();
        }
}
