#include <iostream>
#include <iomanip>
#include <socklibpp/socklistener.h>

#include <csignal>

using namespace std;
using namespace socklibpp;

listener<> connections;

bool send_back(sock sb, int)
{
        char buffer[256];
        int r = sb.recv(buffer, sizeof buffer);
        if (r<1) {
                sb.close();
                return true;   // remove it from the listener
        }
        if (sb.send(buffer, r) < r) {
                sb.close();
                return true;
        }
        return false;
}

int main()
{
        addr_in local(addr_in::addr_any, 0);
        local.port("echo");

        sock server;
        server.create(sock::pf_inet, sock::sock_stream);

        if (!server.bind(local)) {
                cerr << "Could not bind: " << server.error << endl;
                return 1;
        }
        if (!server.listen()) {
                cerr << "Could not listen: " << server.error << endl;
                return 1;
        }

        cout << "Running echo server on " << local << endl;

        while (1) {
                long s = 10;
                long u = 0;
                if (server.wait_read(u, s)) {
                        connections.add(server.accept());
                }

                connections.for_each_read(send_back);
        }
}
