#include <iostream>
#include <exception>
#include <string>

#include <socklibpp/sockstream.h>

using namespace std;
using namespace socklibpp;

int main()
{
        addr_in local(addr_in::addr_any, 0);
        local.port("echo");
        
        sock server;
        server.create(sock::pf_inet, sock::sock_stream);
        
        if (!server.bind(local)) {
                cerr << "Could not bind: " << server.error << endl;
                return 1;
        }
        if (!server.listen()) {
                cerr << "Could not listen: " << server.error << endl;
                return 1;
        }

        sock client;
        string line;
        while (true) {
                client = server.accept();
                
                sockstream con(client);
                con.exceptions(ios_base::eofbit);
                
                try {
                        while (getline(con, line))
                                con << line << crlf;
                }
                catch (sockstream::failure) {
                        cerr << "Lost connection" << endl;
                }
        }
}
